// COSC 4P76 - Project
// Michael Gircys (mg12vp, 5269550)
// 2016-04-21

package ec.app.COSC4P76_Proj;

//Enumeration of possible features to be computed for each region in the image
public enum FeatureType
{
	// Colour Moments (f01-f09)
	Colour_H_Mean,
	Colour_H_StdDev,
	Colour_H_Skew,
	Colour_S_Mean,
	Colour_S_StdDev,
	Colour_S_Skew,
	Colour_V_Mean,
	Colour_V_StdDev,
	Colour_V_Skew,
	// "Lightness" (f10)
	Benford_Lightness,
	// Textures (f11-f18)
	LBP_Bin1_Mean,
	LBP_Bin2_Mean,
	LBP_Bin3_Mean,
	LBP_Bin4_Mean,
	LBP_Bin1_StdDev,
	LBP_Bin2_StdDev,
	LBP_Bin3_StdDev,
	LBP_Bin4_StdDev,
	// Complexity (f19-f23)
	Complexity_H,
	Complexity_S,
	Complexity_V,
	Complexity_RGB,
	Complexity_Y709,
	// Order (f24)
	Order_FractalCompression,
	// Machado-Cardoso f(25)
	Metric_MachadoCardoso
}
