// COSC 4P76 - Project
// Michael Gircys (mg12vp, 5269550)
// 2016-04-21

package ec.app.COSC4P76_Proj;

import ec.EvolutionState;
import ec.util.Parameter;
import ec.app.IEAS.IEASProblemForm;
import ec.app.IEAS.IEASEvaluator;

// Evaluator logic which permits ratings through the learning system
// if the user has asked to defer the rating.
@SuppressWarnings("serial")
public class IEASLearningEvaluator extends IEASEvaluator
{
	
	@Override
	public boolean runComplete(final EvolutionState state)
	{
		return ((IEASProblemForm)p_problem).userExited();
	}
	
	@Override
    public void setup(final EvolutionState state, final Parameter base)
    {
        super.setup(state,base);
        if (!(p_problem instanceof IEASLearningProblemForm))
            state.output.fatal("" + this.getClass() + " used, but the Problem is not of IEASProblemForm", base.push(P_PROBLEM));
    } 
	
	@Override
	public void evaluatePopulation(final EvolutionState state)
    {
		IEASLearningProblemForm prob = (IEASLearningProblemForm)p_problem;
		
		// Single Pre-eval notification to IEAS problem manager.
		prob.prepareToUserEvaluate(state);
		
		// Initial render / preparation; Threaded.
		SimpleEvaluator_EvaluatePopulation(state);
		
		// User fitness!
		prob.userEvaluate(state);
		
		// Single post-eval notification to IEAS problem manager
		prob.userEvaluationFinished(state);
		
		// User deferred? Fitness from learning systems.
		boolean isEvaluationAutomated = prob.isUserDeferringRating();
		if(isEvaluationAutomated)
			prob.learnerEvaluate(state);
		
		// Probably a lot of extra phenotype and analysis data floating around.
		System.gc();
    }
	
}
