// COSC 4P76 - Project
// Michael Gircys (mg12vp, 5269550)
// 2016-04-21

package ec.app.COSC4P76_Proj;

import ec.EvolutionState;
import ec.app.IEAS.IEASProblemForm;

// Extended IEAS problem form which allows for user rating deferral
// and fitness assigned from thelearning system
public interface IEASLearningProblemForm extends IEASProblemForm
{
	
	public void learnerEvaluate(final EvolutionState state);
	
	public boolean isUserDeferringRating();
	
	// Inherited:
	
	// evaluate(...) is now used to produce the phenotype, as it leverages itself to the
	// multi-threading support granted by the built-in evaluation wrappers.
	
	// Called when all individuals have a generated phenotype,
	// should be used to launch the screen for user input.
	//public void userEvaluate(final EvolutionState state);
	
	// Called before the prepareToEvaluate, and thus before the phenotype has been created.
	// Used to notify the user that phenotypes are being created, 
	// or, to begin user evaluation (and filling pending phenotypes in as they complete).
	//public void prepareToUserEvaluate(final EvolutionState state);
	
	// Called after userEvaluate. Not the most useful at the moment.
	// Maybe scale or adjust the fitness provided from the user?
	//public void userEvaluationFinished(final EvolutionState state);
	
	// The user had explicitly signalled that they no longer wish to evolve the population.
	//public boolean userExited();
	
}
