// COSC 4P76 - Project
// Michael Gircys (mg12vp, 5269550)
// 2016-04-21

package ec.app.COSC4P76_Proj;

// Class to compute and hold the first three moments of a distribution
public class Moments 
{	
	public double Mean   = 0.0f;
	public double StdDev = 0.0f;
	public double Skew   = 0.0f;
	
	public Moments( double[] dataset )
	{
		FindMean(   dataset );
		FindStdDev( dataset );
		FindSkew(   dataset );
	}
	
	private void FindMean( double[] dataset )
	{
		for(int i = 0; i < dataset.length; i++)
			Mean += dataset[i];
		Mean /= ((double)(dataset.length));
	}
	private void FindStdDev( double[] dataset )
	{
		for(int i = 0; i < dataset.length; i++)
			StdDev += Math.pow((Mean - dataset[i]), 2);
		StdDev /= ((double)(dataset.length));
		StdDev = (double)(Math.sqrt(StdDev));
	}
	private void FindSkew( double[] dataset )
	{
		// <http://www.itl.nist.gov/div898/handbook/eda/section3/eda35b.htm>
		// <http://mathworld.wolfram.com/MomentalSkewness.html>
		// <http://ncalculators.com/statistics/skewness-calculator.htm>
		for(int i = 0; i < dataset.length; i++)
			Skew += Math.pow((dataset[i] - Mean), 3);
		Skew /= 2 * Math.pow(StdDev,3);
	}
	
}
