package ec.app.COSC5P71_Proj;

import ec.EvolutionState;
import ec.simple.SimpleEvaluator;
import ec.util.Parameter;


@SuppressWarnings("serial")
public class IEASEvaluator extends SimpleEvaluator
{
	
	
	@Override
	public boolean runComplete(final EvolutionState state)
	{
		return ((IEASProblemForm)p_problem).userExited();
	}
	
	@Override
    public void setup(final EvolutionState state, final Parameter base)
    {
        super.setup(state,base);
        if (!(p_problem instanceof IEASProblemForm))
            state.output.fatal("" + this.getClass() + " used, but the Problem is not of IEASProblemForm", base.push(P_PROBLEM));
    } 
	
	@Override
	public void evaluatePopulation(final EvolutionState state)
    {
		IEASProblemForm prob = (IEASProblemForm)p_problem;
		
		// Single Pre-eval notification to IEAS problem manager.
		prob.prepareToUserEvaluate(state);
		
		// Initial render / preparation
		// Threaded.
		super.evaluatePopulation(state);
		
		// User fitness!
		prob.userEvaluate(state);
		
		// Single post-eval notification to IEAS problem manager
		prob.userEvaluationFinished(state);
		
		// Probably a lot of extra phenotype data floating around.
		System.gc();
    }
	
}
