package ec.app.COSC5P71_Proj;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Hashtable;
import javax.swing.*;
import ec.EvolutionState;
import ec.gp.koza.KozaFitness;


@SuppressWarnings("serial")
public class IEASImageRatingComponent extends JPanel
{	
	protected static Hashtable<Integer,JComponent> RatingLabels = null;
	
	protected EvolutionState BoundState;
	protected IEASIndividual BoundIndividual;
	
	public JLabel  ImageLabel;
	public JSlider RatingSlider;
	
	
	public IEASImageRatingComponent(IEASIndividual indv, EvolutionState state) 
	{
		BoundIndividual = indv;
		BoundState = state;
		initialize();
	}

	protected void initialize()
	{
		Dimension sizing = new Dimension(BoundIndividual.Rendering.getWidth()+50, BoundIndividual.Rendering.getHeight());
		this.setLayout(new GridBagLayout());
		this.setMinimumSize( sizing );
		this.setMaximumSize( sizing );
		this.setPreferredSize(sizing);
		this.setBackground(Color.WHITE);
	
		GridBagConstraints c = null;
		
		// Paint the image
		Dimension picSizing = new Dimension(BoundIndividual.Rendering.getWidth(), BoundIndividual.Rendering.getHeight());
		ImageLabel = new JLabel(new ImageIcon( BoundIndividual.Rendering ));
		ImageLabel.setBorder( BorderFactory.createLineBorder(Color.BLACK,1) );
		ImageLabel.setMinimumSize( picSizing );
		ImageLabel.setMaximumSize( picSizing );
		ImageLabel.setPreferredSize(picSizing);
		c = new GridBagConstraints();
		c.anchor = GridBagConstraints.FIRST_LINE_START;
		c.fill = GridBagConstraints.NONE;
		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 0.0;
		c.weighty = 0.0;
		this.add(ImageLabel,c);

		// Rating slider
		initializeRatingLabels();
		RatingSlider = new JSlider(JSlider.VERTICAL, 1, 5, 3);
		RatingSlider.setLabelTable(RatingLabels);
		RatingSlider.setMajorTickSpacing(1);
		RatingSlider.setPaintLabels(true);
		RatingSlider.setPaintTicks(true);
		RatingSlider.setPaintTrack(false);
		RatingSlider.setBackground(Color.WHITE);
		c = new GridBagConstraints();
		c.anchor = GridBagConstraints.CENTER;
		c.fill = GridBagConstraints.VERTICAL;
		c.gridx = 1;
		c.gridy = 0;
		c.weightx = 1.0;
		c.weighty = 1.0;
		this.add(RatingSlider,c);

		// Click on the image for details
		ImageLabel.addMouseListener(new MouseAdapter(){
			@Override
			public void mouseClicked(MouseEvent e)
			{
				IEASImageDetailWindow wind = IEASImageDetailWindow.GetWindow(BoundIndividual, BoundState);
				wind.setVisible(true);
			}
		});
	}
	
	public void Confirm()
	{
		int hits = RatingSlider.getValue(); 		// [1,5]
		double fitness = ((double)(hits-1)) / 4.0;	// [0.0,1.0] with 1.0 best
		
		// Better be Koza fitness.
		KozaFitness f = (KozaFitness)(BoundIndividual.fitness);
		f.hits = hits;
		f.setStandardizedFitness(BoundState, 1.0 - fitness);
	}
	
	protected void initializeRatingLabels()
	{
		if(RatingLabels!=null) return;		
		RatingLabels = new Hashtable<Integer,JComponent>();
		
		RatingLabels.put( (Integer)5, new JLabel("++") );
		RatingLabels.put( (Integer)4, new JLabel("+") );
		RatingLabels.put( (Integer)3, new JLabel("o") );
		RatingLabels.put( (Integer)2, new JLabel("-") );
		RatingLabels.put( (Integer)1, new JLabel("--") );
	}
	
}
