package ec.app.COSC5P71_Proj;

import ec.EvolutionState;
import ec.simple.SimpleProblemForm;


public interface IEASProblemForm extends SimpleProblemForm
{

	// evaluate(...) is now used to produce the phenotype, as it leverages itself to the
	// multi-threading support granted by the built-in evaluation wrappers.
	
	// Called when all individuals have a generated phenotype,
	// should be used to launch the screen for user input.
	public void userEvaluate(final EvolutionState state);
	
	// Called before the prepareToEvaluate, and thus before the phenotype has been created.
	// Used to notify the user that phenotypes are being created, 
	// or, to begin user evaluation (and filling pending phenotypes in as they complete).
	public void prepareToUserEvaluate(final EvolutionState state);
	
	// Called after userEvaluate. Not the most useful at the moment.
	// Maybe scale or adjust the fitness provided from the user?
	public void userEvaluationFinished(final EvolutionState state);
	
	// The user had explicitly signalled that they no longer wish to evolve the population.
	public boolean userExited();
	
}
