package ec.app.IEAS;
import ec.*;
import ec.gp.*;

@SuppressWarnings("serial")
public abstract class Func_Constants extends GPNode
{
	public String toString()         { return String.valueOf(getValue()); }
	public double getValue()         { return 0.0; }
	public int    expectedChildren() { return 0;   }
	public void eval(
    	final EvolutionState state,
        final int            thread,
        final GPData         input,
        final ADFStack       stack,
        final GPIndividual   individual,
        final Problem        problem
    )
    {
        MultiData rd = ((MultiData)(input));
        rd.SetTo(  getValue()  );
    }

	
	public static class Zero extends Func_Constants
	{
	    public double getValue() { return 0.0; }
	}
	public static class Half extends Func_Constants
	{
	    public double getValue() { return 0.5; }
	}
	public static class One extends Func_Constants
	{
		public double getValue() { return 1.0; }
	}
	public static class Two extends Func_Constants
	{
		public double getValue() { return 2.0; }
	}
	
	public static class Pi extends Func_Constants
	{
		public double getValue() { return Math.PI; }
		public String toString() { return "Pi"; } 
	}
	public static class Tau extends Func_Constants
	{
		public double getValue() { return 2.0 * Math.PI; }
		public String toString() { return "Tau"; }
	}
	public static class E extends Func_Constants
	{
		public double getValue() { return Math.E; }
		public String toString() { return "E"; }
	}
	public static class Ratio_Golden extends Func_Constants
	{
		public double getValue() { return 1.6180339887498948482; }
		public String toString() { return "R_Au"; }
	}
	public static class Ratio_Silver extends Func_Constants
	{
		public double getValue() { return 2.4142135623730950488; }
		public String toString() { return "R_Ag"; }
	}
}
