package ec.app.IEAS;

import ec.EvolutionState;
import ec.simple.SimpleEvaluator;
import ec.util.Parameter;


@SuppressWarnings("serial")
public class IEASEvaluator extends SimpleEvaluator
{
	
	
	@Override
	public boolean runComplete(final EvolutionState state)
	{
		return ((IEASProblemForm)p_problem).userExited();
	}
	
	@Override
    public void setup(final EvolutionState state, final Parameter base)
    {
        super.setup(state,base);
        if (!(p_problem instanceof IEASProblemForm))
            state.output.fatal("" + this.getClass() + " used, but the Problem is not of IEASProblemForm", base.push(P_PROBLEM));
    } 
	
	// Provide access to the inherited SimpleEvaluator.evaluatePopulation method.
	// Extensions to this evaluator probably don't want to call super on its
	// provided evaluatePopulation, unless it really wants to give
	// multiple calls to the prepareToUserEvaluate()... , etc, methods.
	public void SimpleEvaluator_EvaluatePopulation(final EvolutionState state)
	{
		super.evaluatePopulation(state);
	}
	
	@Override
	public void evaluatePopulation(final EvolutionState state)
    {
		IEASProblemForm prob = (IEASProblemForm)p_problem;SimpleEvaluator_EvaluatePopulation(state);SimpleEvaluator_EvaluatePopulation(state);
		
		// Single Pre-eval notification to IEAS problem manager.
		prob.prepareToUserEvaluate(state);
		
		// Initial render / preparation; Threaded
		SimpleEvaluator_EvaluatePopulation(state);
		
		// User fitness!
		prob.userEvaluate(state);
		
		// Single post-eval notification to IEAS problem manager
		prob.userEvaluationFinished(state);
		
		// Probably a lot of extra phenotype data floating around.
		System.gc();
    }
	
}
