package ec.app.IEAS;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.WritableRaster;

import ec.gp.*;

@SuppressWarnings("serial")
public class MultiData extends GPData
{
    private double[]      double_data  = new double[3];
	private BufferedImage texture_data = null;
	
	
	@Override
    public void copyTo(final GPData gpd)
    {
    	MultiData to = ((MultiData)gpd);
    	
    	to.double_data = new double[this.double_data.length];
    	System.arraycopy(this.double_data, 0, to.double_data, 0, to.double_data.length);
    	
    	to.texture_data = deepCopy(texture_data);
    }
    
    @Override
    public Object clone()
    {
    	MultiData other = (MultiData)(super.clone());
    	
    	other.double_data  = (double[])(double_data.clone());
    	other.texture_data = deepCopy(texture_data) ;
    	
    	return other;
    }
    
    
    static BufferedImage deepCopy(BufferedImage bi) 
    {
    	if(bi == null) return null;
		ColorModel cm = bi.getColorModel();
		boolean isAlphaPremultiplied = cm.isAlphaPremultiplied();
		WritableRaster raster = bi.copyData(null);
		return new BufferedImage(cm, raster, isAlphaPremultiplied, null);
	}
    
    
    public BufferedImage GetT() { return texture_data;          }
    public double        GetD() { return double_data[0];        }
    public double[]      GetS() { return double_data;           }
    public boolean       GetB() { return double_data[0] != 0.0; }
    
    public void SetTo(BufferedImage v) { texture_data = v;                }
    public void SetTo(double        v) { double_data[0] = v;              }
    public void SetTo(double[]      v) { double_data = v;                 }
    public void SetTo(boolean       v) { double_data[0] = v ? 1.0 : 0.0 ; }
    
}
